import { createSocket, closeWebSocket } from '@/utils/webSocket'

const state = {
  socketStatus: false,
  noticeList: [],
  errorMessage: ''
}

const mutations = {
  ON_ERROR(state, message) {
    state.errorMessage = message
  },
  ON_OPEN(state) {
    state.socketStatus = true
  },
  ON_MESSAGE(state, data) {
    console.log(data)
  },
  ON_CLOSE(state) {
    state.noticeList = []
    state.socketStatus = false
  }
}

const actions = {
  start({ commit }) {
    const options = {
      onopen: () => commit('ON_OPEN'),
      onerror: (message) => commit('ON_ERROR', message),
      onmessage: (data) => commit('ON_MESSAGE', data),
      onclose: () => commit('ON_CLOSE')
    }
    createSocket(options, (message) => commit('ON_ERROR', message))
  },
  close: () => closeWebSocket()
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
